// Copyright 2016 Orus.io. All rights reserved.

package main

import (
	"github.com/spf13/cobra"

	"xbus.io/go-xbus"
	"xbus.io/go-xbus/cmd"
	_ "xbus.io/go-xbus/demo"
	"bitbucket.org/orus-io/xbus/utils/license"
	"bitbucket.org/orus-io/xbus/version"
)

func init() {
	xbus.ClientName = "xbus-client"
	xbus.ClientVersion = version.Version

	cmd.RootCmd.Run = version.Cmd
	flags := cmd.RootCmd.PersistentFlags()
	version.InitFlags(flags)

	cobra.OnInitialize(func() {
		license.SetupLicenseWatcher(cmd.Logger)
	})
	license.SetupCmd(cmd.RootCmd)
}

func main() {
	license.DisplayLicenseOnStart()
	cmd.Execute()
}
