from docutils.parsers.rst import Directive
from docutils import nodes

import subprocess


class AutoCmdDirective(Directive):
    required_arguments = 1
    optional_arguments = 5
    has_content = True

    def run(self):
        content = subprocess.check_output(
            self.arguments + ["--help"],
            stderr=subprocess.STDOUT
        ).decode('utf-8')

        return [
            nodes.literal_block(content, content)
        ]


def setup(app):
    app.add_directive('autocmd', AutoCmdDirective)
    return {}
