#!/bin/bash

if [ -e .hg ]; then
    VERSION=$(cat version.txt)
    TAGS=$(hg id --tags)
    HASH=$(hg id --debug --id)
    HASH_SHORT=$(hg log -r . -T '{node}'| head -c 12)
    TOPIC=$(hg log -r . -T '{topics}')


    if [ -z "$TAGS" -o "$TAGS" != "$VERSION" ]; then
        VNAME=dev
        if [ -n "$CI" ]; then
            VNAME=ci
        fi
        if [ -n "$CI_COMMIT_REF_SLUG" ]; then
            VERSION="$VERSION.$CI_COMMIT_REF_SLUG"
        fi
        VERSION="$VERSION.$VNAME.$(date +%Y%m%d.%H%M%S).$HASH_SHORT"
    fi
else
    if [ ! -e version/constants.go ]; then
        echo "MISSING version/constants.go"
        exit 1
    fi
    VERSION=`grep "Version =" version/constants.go |sed 's/.*"\(.*\)"/\1/'`
fi

echo $VERSION
