// Copyright 2016 Orus.io. All rights reserved.

package control

import (
	"context"

	"xbus.io/go-xbus/api"
	"xbus.io/go-xbus/api/control"
)

type envelopeServer struct {
	*Service
}

func (s envelopeServer) Purge(
	ctx context.Context,
	send func(control.TaskProgress),
) (err error) {
	var count uint32
	s.o.EnvelopeStorage.Purge(func(ids []api.UUID) []api.UUID {
		select {
		case <-ctx.Done():
			panic(nil)
		default:
		}
		var result []api.UUID
		envProcess := s.o.ProcessStorage.FindProcessForEnvelope(ids)
		for _, id := range ids {
			if _, ok := envProcess[id]; !ok {
				result = append(result, id)
				count++
			}
		}
		send(control.TaskProgress{Progression: count})
		return result
	})
	return nil
}
