// Copyright 2016 Orus.io. All rights reserved.

package model

import (
	"fmt"

	"github.com/orus-io/yago"
	"github.com/slicebit/qb"

	"xbus.io/go-xbus"
)

// NewDB initialize a Model and a DB
func NewDB(driver string, params string, maxConns int, logger xbus.Logger, logFlags qb.LogFlags) (*Model, *yago.DB, error) {
	model := NewModel()
	engine, err := qb.New(driver, params)
	if err != nil {
		return nil, nil, fmt.Errorf("DB engine initialization failed: %s", err)
	}
	engine.SetDialect(qb.NewDialect(driver))
	engine.SetLogger(&QBLogger{logger: logger})
	engine.SetLogFlags(logFlags)
	engine.DB().SetMaxOpenConns(maxConns)

	db := yago.New(model.Meta, engine)

	return model, db, nil
}
