package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// EnvelopeTypesKnown is the TypesKnown field name
	EnvelopeTypesKnown = "TypesKnown"
	// EnvelopeTypesKnownColumnName is the TypesKnown field associated column name
	EnvelopeTypesKnownColumnName = "types_known"
	// EnvelopeEventIDs is the EventIDs field name
	EnvelopeEventIDs = "EventIDs"
	// EnvelopeEventIDsColumnName is the EventIDs field associated column name
	EnvelopeEventIDsColumnName = "event_ids"
	// EnvelopeStatus is the Status field name
	EnvelopeStatus = "Status"
	// EnvelopeStatusColumnName is the Status field associated column name
	EnvelopeStatusColumnName = "status"
	// EnvelopeError is the Error field name
	EnvelopeError = "Error"
	// EnvelopeErrorColumnName is the Error field associated column name
	EnvelopeErrorColumnName = "error"
)

const (
	// EnvelopeTableName is the Envelope associated table name
	EnvelopeTableName = "envelope"
)

var envelopeTable = qb.Table(
	EnvelopeTableName,
	qb.Column(EnvelopeTypesKnownColumnName, qb.Boolean()).NotNull(),
	qb.Column(EnvelopeEventIDsColumnName, qb.Text()).NotNull(),
	qb.Column(EnvelopeStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(EnvelopeErrorColumnName, qb.Varchar()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
)

var envelopeType = reflect.TypeOf(Envelope{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Envelope) StructType() reflect.Type {
	return envelopeType
}

// EnvelopeModel provides direct access to helpers for Envelope
// queries
type EnvelopeModel struct {
	mapper     *EnvelopeMapper
	TypesKnown yago.ScalarField
	EventIDs   yago.ScalarField
	Status     yago.MarshaledScalarField
	Error      yago.ScalarField
	ID         yago.ScalarField
	CreatedAt  yago.ScalarField
	UpdatedAt  yago.ScalarField
}

// NewEnvelopeModel returns a new EnvelopeModel
func NewEnvelopeModel(meta *yago.Metadata) EnvelopeModel {
	mapper := NewEnvelopeMapper()
	meta.AddMapper(mapper)
	return EnvelopeModel{
		mapper:     mapper,
		TypesKnown: yago.NewScalarField(mapper.Table().C(EnvelopeTypesKnownColumnName)),
		EventIDs:   yago.NewScalarField(mapper.Table().C(EnvelopeEventIDsColumnName)),
		Status:     yago.NewMarshaledScalarField(mapper.Table().C(EnvelopeStatusColumnName)),
		Error:      yago.NewScalarField(mapper.Table().C(EnvelopeErrorColumnName)),
		ID:         yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt:  yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt:  yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated EnvelopeMapper instance
func (m EnvelopeModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewEnvelopeMapper initialize a NewEnvelopeMapper
func NewEnvelopeMapper() *EnvelopeMapper {
	m := &EnvelopeMapper{}
	return m
}

// EnvelopeMapper is the Envelope mapper
type EnvelopeMapper struct{}

// GetMapper returns itself
func (mapper *EnvelopeMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*EnvelopeMapper) Name() string {
	return "model/Envelope"
}

// Table returns the mapper table
func (*EnvelopeMapper) Table() *qb.TableElem {
	return &envelopeTable
}

// StructType returns the reflect.Type of the mapped structure
func (EnvelopeMapper) StructType() reflect.Type {
	return envelopeType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper EnvelopeMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Envelope)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Envelope{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, EnvelopeTypesKnown) {
		m[EnvelopeTypesKnownColumnName] = s.TypesKnown
	}
	if allValues || yago.StringListContains(fields, EnvelopeEventIDs) {
		m[EnvelopeEventIDsColumnName] = s.EventIDs
	}
	if allValues || yago.StringListContains(fields, EnvelopeStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[EnvelopeStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, EnvelopeError) {
		m[EnvelopeErrorColumnName] = s.Error
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper EnvelopeMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		envelopeTable.C(EnvelopeTypesKnownColumnName),
		envelopeTable.C(EnvelopeEventIDsColumnName),
		envelopeTable.C(EnvelopeStatusColumnName),
		envelopeTable.C(EnvelopeErrorColumnName),
		envelopeTable.C(BaseIDColumnName),
		envelopeTable.C(BaseCreatedAtColumnName),
		envelopeTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper EnvelopeMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Envelope)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Envelope{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper EnvelopeMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Envelope)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Envelope{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	if err := rows.Scan(
		&s.TypesKnown,
		&s.EventIDs,
		&StatusText,
		&s.Error,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (EnvelopeMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (EnvelopeMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Envelope has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper EnvelopeMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Envelope)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper EnvelopeMapper) PKeyClause(values []interface{}) qb.Clause {
	return envelopeTable.C(BaseIDColumnName).Eq(values[0])
}

const (
	// EventID is the ID field name
	EventID = "ID"
	// EventIDColumnName is the ID field associated column name
	EventIDColumnName = "id"
	// EventEnvelopeID is the EnvelopeID field name
	EventEnvelopeID = "EnvelopeID"
	// EventEnvelopeIDColumnName is the EnvelopeID field associated column name
	EventEnvelopeIDColumnName = "envelope_id"
	// EventEventID is the EventID field name
	EventEventID = "EventID"
	// EventEventIDColumnName is the EventID field associated column name
	EventEventIDColumnName = "event_id"
	// EventEventType is the EventType field name
	EventEventType = "EventType"
	// EventEventTypeColumnName is the EventType field associated column name
	EventEventTypeColumnName = "event_type"
	// EventStatus is the Status field name
	EventStatus = "Status"
	// EventStatusColumnName is the Status field associated column name
	EventStatusColumnName = "status"
	// EventItemCount is the ItemCount field name
	EventItemCount = "ItemCount"
	// EventItemCountColumnName is the ItemCount field associated column name
	EventItemCountColumnName = "item_count"
	// EventChecksum is the Checksum field name
	EventChecksum = "Checksum"
	// EventChecksumColumnName is the Checksum field associated column name
	EventChecksumColumnName = "checksum"
	// EventValidator is the Validator field name
	EventValidator = "Validator"
	// EventValidatorColumnName is the Validator field associated column name
	EventValidatorColumnName = "validator"
)

const (
	// EventTableName is the Event associated table name
	EventTableName = "event"
)

var eventTable = qb.Table(
	EventTableName,
	qb.Column(EventIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(EventEnvelopeIDColumnName, qb.UUID()).NotNull(),
	qb.Column(EventEventIDColumnName, qb.UUID()).NotNull(),
	qb.Column(EventEventTypeColumnName, qb.Varchar()).NotNull(),
	qb.Column(EventStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(EventItemCountColumnName, qb.BigInt().Unsigned()).NotNull(),
	qb.Column(EventChecksumColumnName, qb.Int().Unsigned()).NotNull(),
	qb.Column(EventValidatorColumnName, qb.Varchar()).NotNull(),
	qb.UniqueKey(
		EventEnvelopeIDColumnName,
		EventEventIDColumnName,
	),
	qb.ForeignKey(EventEnvelopeIDColumnName).References(EnvelopeTableName, BaseIDColumnName).OnDelete("CASCADE"),
)

var eventType = reflect.TypeOf(Event{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Event) StructType() reflect.Type {
	return eventType
}

// EventModel provides direct access to helpers for Event
// queries
type EventModel struct {
	mapper     *EventMapper
	ID         yago.ScalarField
	EnvelopeID yago.ScalarField
	EventID    yago.ScalarField
	EventType  yago.ScalarField
	Status     yago.MarshaledScalarField
	ItemCount  yago.ScalarField
	Checksum   yago.ScalarField
	Validator  yago.ScalarField
}

// NewEventModel returns a new EventModel
func NewEventModel(meta *yago.Metadata) EventModel {
	mapper := NewEventMapper()
	meta.AddMapper(mapper)
	return EventModel{
		mapper:     mapper,
		ID:         yago.NewScalarField(mapper.Table().C(EventIDColumnName)),
		EnvelopeID: yago.NewScalarField(mapper.Table().C(EventEnvelopeIDColumnName)),
		EventID:    yago.NewScalarField(mapper.Table().C(EventEventIDColumnName)),
		EventType:  yago.NewScalarField(mapper.Table().C(EventEventTypeColumnName)),
		Status:     yago.NewMarshaledScalarField(mapper.Table().C(EventStatusColumnName)),
		ItemCount:  yago.NewScalarField(mapper.Table().C(EventItemCountColumnName)),
		Checksum:   yago.NewScalarField(mapper.Table().C(EventChecksumColumnName)),
		Validator:  yago.NewScalarField(mapper.Table().C(EventValidatorColumnName)),
	}
}

// GetMapper returns the associated EventMapper instance
func (m EventModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewEventMapper initialize a NewEventMapper
func NewEventMapper() *EventMapper {
	m := &EventMapper{}
	return m
}

// EventMapper is the Event mapper
type EventMapper struct{}

// GetMapper returns itself
func (mapper *EventMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*EventMapper) Name() string {
	return "model/Event"
}

// Table returns the mapper table
func (*EventMapper) Table() *qb.TableElem {
	return &eventTable
}

// StructType returns the reflect.Type of the mapped structure
func (EventMapper) StructType() reflect.Type {
	return eventType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper EventMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Event)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Event{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[EventIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, EventEnvelopeID) {
		m[EventEnvelopeIDColumnName] = s.EnvelopeID
	}
	if allValues || yago.StringListContains(fields, EventEventID) {
		m[EventEventIDColumnName] = s.EventID
	}
	if allValues || yago.StringListContains(fields, EventEventType) {
		m[EventEventTypeColumnName] = s.EventType
	}
	if allValues || yago.StringListContains(fields, EventStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[EventStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, EventItemCount) {
		m[EventItemCountColumnName] = s.ItemCount
	}
	if allValues || yago.StringListContains(fields, EventChecksum) {
		m[EventChecksumColumnName] = s.Checksum
	}
	if allValues || yago.StringListContains(fields, EventValidator) {
		m[EventValidatorColumnName] = s.Validator
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper EventMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		eventTable.C(EventIDColumnName),
		eventTable.C(EventEnvelopeIDColumnName),
		eventTable.C(EventEventIDColumnName),
		eventTable.C(EventEventTypeColumnName),
		eventTable.C(EventStatusColumnName),
		eventTable.C(EventItemCountColumnName),
		eventTable.C(EventChecksumColumnName),
		eventTable.C(EventValidatorColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper EventMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Event)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Event{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper EventMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Event)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Event{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	if err := rows.Scan(
		&s.ID,
		&s.EnvelopeID,
		&s.EventID,
		&s.EventType,
		&StatusText,
		&s.ItemCount,
		&s.Checksum,
		&s.Validator,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (EventMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (EventMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*Event)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper EventMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Event)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper EventMapper) PKeyClause(values []interface{}) qb.Clause {
	return eventTable.C(EventIDColumnName).Eq(values[0])
}

const (
	// ItemID is the ID field name
	ItemID = "ID"
	// ItemIDColumnName is the ID field associated column name
	ItemIDColumnName = "id"
	// ItemEventID is the EventID field name
	ItemEventID = "EventID"
	// ItemEventIDColumnName is the EventID field associated column name
	ItemEventIDColumnName = "event_id"
	// ItemBatch is the Batch field name
	ItemBatch = "Batch"
	// ItemBatchColumnName is the Batch field associated column name
	ItemBatchColumnName = "batch"
	// ItemIndex is the Index field name
	ItemIndex = "Index"
	// ItemIndexColumnName is the Index field associated column name
	ItemIndexColumnName = "index_"
	// ItemData is the Data field name
	ItemData = "Data"
	// ItemDataColumnName is the Data field associated column name
	ItemDataColumnName = "data"
)

const (
	// ItemTableName is the Item associated table name
	ItemTableName = "item"
)

var itemTable = qb.Table(
	ItemTableName,
	qb.Column(ItemIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(ItemEventIDColumnName, qb.BigInt()).NotNull(),
	qb.Column(ItemBatchColumnName, qb.BigInt().Unsigned()).NotNull(),
	qb.Column(ItemIndexColumnName, qb.BigInt()).NotNull(),
	qb.Column(ItemDataColumnName, qb.Blob()).NotNull(),
	qb.ForeignKey(ItemEventIDColumnName).References(EventTableName, EventIDColumnName).OnDelete("CASCADE"),
).Index(
	ItemEventIDColumnName,
	ItemIndexColumnName,
)

var itemType = reflect.TypeOf(Item{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Item) StructType() reflect.Type {
	return itemType
}

// ItemModel provides direct access to helpers for Item
// queries
type ItemModel struct {
	mapper  *ItemMapper
	ID      yago.ScalarField
	EventID yago.ScalarField
	Batch   yago.ScalarField
	Index   yago.ScalarField
	Data    yago.ScalarField
}

// NewItemModel returns a new ItemModel
func NewItemModel(meta *yago.Metadata) ItemModel {
	mapper := NewItemMapper()
	meta.AddMapper(mapper)
	return ItemModel{
		mapper:  mapper,
		ID:      yago.NewScalarField(mapper.Table().C(ItemIDColumnName)),
		EventID: yago.NewScalarField(mapper.Table().C(ItemEventIDColumnName)),
		Batch:   yago.NewScalarField(mapper.Table().C(ItemBatchColumnName)),
		Index:   yago.NewScalarField(mapper.Table().C(ItemIndexColumnName)),
		Data:    yago.NewScalarField(mapper.Table().C(ItemDataColumnName)),
	}
}

// GetMapper returns the associated ItemMapper instance
func (m ItemModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewItemMapper initialize a NewItemMapper
func NewItemMapper() *ItemMapper {
	m := &ItemMapper{}
	return m
}

// ItemMapper is the Item mapper
type ItemMapper struct{}

// GetMapper returns itself
func (mapper *ItemMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*ItemMapper) Name() string {
	return "model/Item"
}

// Table returns the mapper table
func (*ItemMapper) Table() *qb.TableElem {
	return &itemTable
}

// StructType returns the reflect.Type of the mapped structure
func (ItemMapper) StructType() reflect.Type {
	return itemType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper ItemMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Item)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Item{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[ItemIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, ItemEventID) {
		m[ItemEventIDColumnName] = s.EventID
	}
	if allValues || yago.StringListContains(fields, ItemBatch) {
		m[ItemBatchColumnName] = s.Batch
	}
	if allValues || yago.StringListContains(fields, ItemIndex) {
		m[ItemIndexColumnName] = s.Index
	}
	if allValues || yago.StringListContains(fields, ItemData) {
		m[ItemDataColumnName] = s.Data
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper ItemMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		itemTable.C(ItemIDColumnName),
		itemTable.C(ItemEventIDColumnName),
		itemTable.C(ItemBatchColumnName),
		itemTable.C(ItemIndexColumnName),
		itemTable.C(ItemDataColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper ItemMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Item)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Item{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper ItemMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Item)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Item{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.EventID,
		&s.Batch,
		&s.Index,
		&s.Data,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (ItemMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (ItemMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*Item)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper ItemMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Item)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper ItemMapper) PKeyClause(values []interface{}) qb.Clause {
	return itemTable.C(ItemIDColumnName).Eq(values[0])
}
